import _extends from "@babel/runtime-corejs3/helpers/esm/extends";
import React from 'react';
import warning from 'warning';
export default function renderElement(_ref) {
  var match = _ref.match,
      Component = _ref.Component,
      isComponentResolved = _ref.isComponentResolved,
      hasComponent = _ref.hasComponent,
      querySubscription = _ref.querySubscription,
      resolving = _ref.resolving;
  var route = match.route,
      router = match.router;
  var readyState = querySubscription.readyState,
      environment = querySubscription.environment,
      variables = querySubscription.variables;
  var error = readyState.error,
      props = readyState.props;

  if (!route.render) {
    if (!isComponentResolved || !error && !props) {
      return undefined;
    }

    if (!props || !hasComponent) {
      process.env.NODE_ENV !== "production" ? warning(hasComponent, 'Route with query `%s` has no render method or component.', querySubscription.getQueryName()) : void 0;
      return null;
    }

    return /*#__PURE__*/React.createElement(Component, _extends({
      match: match,
      router: router
    }, props));
  }

  return route.render(_extends({}, readyState, {
    match: match,
    Component: isComponentResolved ? Component : null,
    props: props && _extends({
      match: match,
      router: router
    }, props),
    environment: environment,
    variables: variables,
    resolving: resolving
  }));
}